/*
** queue.h - FIFO queue management routines.
**
** Copyright (c) 1997-1999 Peter Eriksson <pen@lysator.liu.se>
**
** This program is free software; you can redistribute it and/or
** modify it as you wish - as long as you don't claim that you wrote
** it.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
*/

#ifndef PLIB_QUEUE_H
#define PLIB_QUEUE_H

#include "plib/threads.h"

typedef struct
{
    void **buf;
    int qsize;
    int occupied;
    int nextin;
    int nextout;
    pthread_mutex_t mtx;
    pthread_cond_t more;
    pthread_cond_t less;
} PQUEUE;


extern int
pqueue_init(PQUEUE *bp,
	   int qsize);

extern void
pqueue_destroy(PQUEUE *bp);

extern void
pqueue_put(PQUEUE *bp,
	  void *item);

extern void *
pqueue_get(PQUEUE *bp);

#endif
    
