/*
** readdir.h - Raw directory read functions
**
** Copyright (c) 1995-1999 Peter Eriksson <pen@signum.se>
**
** This program is free software; you can redistribute it and/or
** modify it as you wish - as long as you don't claim that you wrote
** it.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
*/

#ifndef PLIB_READDIR_H
#define PLIB_READDIR_H

#include <sys/types.h>

#ifdef HAVE_GETDENTS
#include <dirent.h>

typedef struct
{
    int fd;
    int len;
    char buf[8192];
    struct dirent *dep;
} S_DIR;

extern S_DIR *
s_opendir(const char *path);

extern struct dirent *
s_readdir(S_DIR *dp);

extern void
s_closedir(S_DIR *dp);

#else

#include <dirent.h>

#define S_DIR DIR

#define s_opendir(path) opendir(path)
#define s_closedir(dp) closedir(dp)

extern struct dirent *
s_readdir(S_DIR *dp);

#endif

#endif
