/*
** ftpdata.h
**
** Copyright (c) 1999 Peter Eriksson <pen@lysator.liu.se>
**
** This program is free software; you can redistribute it and/or
** modify it as you wish - as long as you don't claim that you wrote
** it.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
*/

#ifndef FTPDATA_H
#define FTPDATA_H

#include "ftpcmd.h"

typedef struct
{
    FTPCLIENT *fp;
    int (*handler)(FTPCLIENT *fp, void *vp);
    void *vp;
} FTPDATA;



/* Initiate a FTPDATA session */
extern int
ftpdata_run(FTPCLIENT *fp,
	    const char *reason,
	    int (*handler)(FTPCLIENT *fp, void *vp),
	    void *vp);



/* Wait for a started FTPDATA session to finish */
extern void
ftpdata_wait(FTPCLIENT *fp);

/* Abort a started FTPDATA session */
extern void
ftpdata_abort(FTPCLIENT *fp);

#endif
